varying vec2 texc;

uniform vec2 ver_brown;
uniform vec2 hor_brown;
uniform vec2 ver2_brown;
uniform vec2 hor2_brown;
uniform vec4 offset_wh;

uniform float intensity_brownsize;
uniform float left_intensity_brownsize;
uniform float right_intensity_brownsize;
uniform float left_scale_brownsize;
uniform float right_scale_brownsize;
uniform sampler2D tex_brownsize;

uniform float intensity_brownshape;
uniform float left_intensity_brownshape;
uniform float right_intensity_brownshape;
uniform float left_scale_brownshape;
uniform float right_scale_brownshape;
uniform sampler2D tex_brownshape;

uniform sampler2D tex_brownmask;
uniform float intensity_brownposition;
uniform float left_intensity_brownposition;
uniform float right_intensity_brownposition;
uniform float left_scale_brownposition;
uniform float right_scale_brownposition;

uniform float intensity_browndistance;
uniform float left_intensity_browndistance;
uniform float right_intensity_browndistance;
uniform float left_scale_browndistance;
uniform float right_scale_browndistance;

uniform float intensity_browntilt;
uniform float left_intensity_browntilt;
uniform float right_intensity_browntilt;
uniform float left_scale_browntilt;
uniform float right_scale_browntilt;
uniform mat4 M_left_browntilt;
uniform mat4 M_right_browntilt;
uniform mat4 left_M_browntilt;
uniform mat4 right_M_browntilt;

uniform float intensity_brownlength;
uniform float left_intensity_brownlength;
uniform float right_intensity_brownlength;
uniform float left_scale_brownlength;
uniform float right_scale_brownlength;
uniform sampler2D tex_brownlength;

uniform sampler2D tex_uv_in;

vec2 BrownSize(vec2 texc_warp) {
    vec2 out_texc = texc_warp;

    vec2 off = abs(vec2(1.0) - texc_warp);
    vec2 off1 = abs(texc_warp);
    vec2 min_off = min(off, off1);
    vec2 modify_intensity = clamp(smoothstep(vec2(0.0), vec2(0.15, 0.1), min_off), vec2(0.55, 0.0), vec2(1.0, 1.0));

    vec4 maskColor = texture2D(tex_brownsize, texc + (out_texc - texc) / offset_wh.zw);
    vec2 newCoords = (maskColor.rg - 127.0 / 255.0) / 25.0;
    vec2 newCoord_x = hor_brown * newCoords.x;
    vec2 newCoord_y = ver_brown * newCoords.y;
    vec2 newCoord2_x = hor2_brown * newCoords.x;
    vec2 newCoord2_y = ver2_brown * newCoords.y;
    if(abs(left_intensity_brownsize) > 0.001){       
        if (maskColor.b < 0.5) {
            out_texc += (newCoord_x + newCoord_y) * maskColor.a * left_intensity_brownsize * modify_intensity * left_scale_brownsize * smoothstep(0.5,0.48,maskColor.b);
        } 
    }

    if(abs(right_intensity_brownsize) > 0.001){
        if (maskColor.b > 0.5) {
           out_texc += (newCoord2_x + newCoord2_y) * maskColor.a * right_intensity_brownsize * modify_intensity * right_scale_brownsize * smoothstep(0.5,0.52,maskColor.b);
        }
    }

    maskColor = texture2D(tex_brownsize, texc + (out_texc - texc) / offset_wh.zw);
    newCoords = (maskColor.rg - 127.0 / 255.0) / 25.0;
    newCoord_x = hor_brown * newCoords.x;
    newCoord_y = ver_brown * newCoords.y;
    newCoord2_x = hor2_brown * newCoords.x;
    newCoord2_y = ver2_brown * newCoords.y;

    if(abs(intensity_brownsize) > 0.001){
        if (maskColor.b < 0.5) {
            out_texc += (newCoord_x + newCoord_y) * maskColor.a * intensity_brownsize * modify_intensity * left_scale_brownsize;
        } else {
            out_texc += (newCoord2_x + newCoord2_y) * maskColor.a * intensity_brownsize * modify_intensity * right_scale_brownsize;
        }
    }
    
    return out_texc;
}

vec2 BrownShape(vec2 texc_warp) {
    vec2 out_texc = texc_warp;

    vec2 off = abs(vec2(1.0) - texc_warp);
    vec2 off1 = abs(texc_warp);
    vec2 min_off = min(off, off1);
    vec2 modify_intensity = clamp(smoothstep(vec2(0.0), vec2(0.15, 0.1), min_off), vec2(0.55, 0.0), vec2(1.0, 1.0));

    vec4 maskColor = texture2D(tex_brownshape, texc + (out_texc - texc) / offset_wh.zw);
    vec2 newCoords = (maskColor.rg - 127.0 / 255.0) / 25.0;
    vec2 newCoord_x = hor_brown * newCoords.x;
    vec2 newCoord_y = ver_brown * newCoords.y;
    vec2 newCoord2_x = hor2_brown * newCoords.x;
    vec2 newCoord2_y = ver2_brown * newCoords.y;
    if(abs(left_intensity_brownshape) > 0.001){       
        if (maskColor.b < 0.5) {
            out_texc += (newCoord_x + newCoord_y) * maskColor.a * left_intensity_brownshape * modify_intensity * left_scale_brownshape * smoothstep(0.5,0.48,maskColor.b);
        } 
    }

    if(abs(right_intensity_brownshape) > 0.001){
        if (maskColor.b > 0.5) {
           out_texc += (newCoord2_x + newCoord2_y) * maskColor.a * right_intensity_brownshape * modify_intensity * right_scale_brownshape * smoothstep(0.5,0.52,maskColor.b);
        }
    }

    maskColor = texture2D(tex_brownshape, texc + (out_texc - texc) / offset_wh.zw);
    newCoords = (maskColor.rg - 127.0 / 255.0) / 25.0;
    newCoord_x = hor_brown * newCoords.x;
    newCoord_y = ver_brown * newCoords.y;
    newCoord2_x = hor2_brown * newCoords.x;
    newCoord2_y = ver2_brown * newCoords.y;

    if(abs(intensity_brownshape) > 0.001){
        if (maskColor.b < 0.5) {
            out_texc += (newCoord_x + newCoord_y) * maskColor.a * intensity_brownshape * modify_intensity * left_scale_brownshape;
        } else {
            out_texc += (newCoord2_x + newCoord2_y) * maskColor.a * intensity_brownshape * modify_intensity * right_scale_brownshape;
        }
    }
    
    return out_texc;
}

vec2 BrownPosition(vec2 texc_warp) {
    vec2 out_texc = texc_warp;

    vec2 off = abs(vec2(1.0) - texc_warp);
    vec2 off1 = abs(texc_warp);
    vec2 min_off = min(off, off1);
    vec2 modify_intensity = clamp(smoothstep(vec2(0.0), vec2(0.15, 0.1), min_off), vec2(0.55, 0.0), vec2(1.0, 1.0));

    vec4 maskColor = texture2D(tex_brownmask, texc + (out_texc - texc) / offset_wh.zw);
    maskColor = vec4(127.0 / 255.0,0.3,maskColor.a,smoothstep(0.0,0.9,maskColor.r));
    vec2 newCoords = (maskColor.rg - 127.0 / 255.0) / 25.0;
    vec2 newCoord_x = hor_brown * newCoords.x;
    vec2 newCoord_y = ver_brown * newCoords.y;
    vec2 newCoord2_x = hor2_brown * newCoords.x;
    vec2 newCoord2_y = ver2_brown * newCoords.y;
    if(abs(left_intensity_brownposition) > 0.001){       
        if (maskColor.b < 0.5) {
            out_texc += (newCoord_x + newCoord_y) * maskColor.a * left_intensity_brownposition * modify_intensity * left_scale_brownposition * smoothstep(0.5,0.48,maskColor.b);
        } 
    }

    if(abs(right_intensity_brownposition) > 0.001){
        if (maskColor.b > 0.5) {
           out_texc += (newCoord2_x + newCoord2_y) * maskColor.a * right_intensity_brownposition * modify_intensity * right_scale_brownposition * smoothstep(0.5,0.52,maskColor.b);
        }
    }

    maskColor = texture2D(tex_brownmask, texc + (out_texc - texc) / offset_wh.zw);
    maskColor = vec4(127.0 / 255.0,0.3,maskColor.a,smoothstep(0.0,0.9,maskColor.r));
    newCoords = (maskColor.rg - 127.0 / 255.0) / 25.0;
    newCoord_x = hor_brown * newCoords.x;
    newCoord_y = ver_brown * newCoords.y;
    newCoord2_x = hor2_brown * newCoords.x;
    newCoord2_y = ver2_brown * newCoords.y;
    if(abs(intensity_brownposition) > 0.001){
        if (maskColor.b < 0.5) {
            out_texc += (newCoord_x + newCoord_y) * maskColor.a * intensity_brownposition * modify_intensity * left_scale_brownposition;
        } else {
            out_texc += (newCoord2_x + newCoord2_y) * maskColor.a * intensity_brownposition * modify_intensity * right_scale_brownposition;
        }
    }
    
    return out_texc;
}

vec2 BrownDistance(vec2 texc_warp) {
    vec2 out_texc = texc_warp;

    vec2 off = abs(vec2(1.0) - texc_warp);
    vec2 off1 = abs(texc_warp);
    vec2 min_off = min(off, off1);
    vec2 modify_intensity = clamp(smoothstep(vec2(0.0), vec2(0.15, 0.1), min_off), vec2(0.55, 0.0), vec2(1.0, 1.0));

    vec4 maskColor = texture2D(tex_brownmask, texc + (out_texc - texc) / offset_wh.zw);
    maskColor = vec4(0.3,127.0 / 255.0,maskColor.a,maskColor.r);
    vec2 newCoords = (maskColor.rg - 127.0 / 255.0) / 25.0;
    vec2 newCoord_x = hor_brown * newCoords.x;
    vec2 newCoord_y = ver_brown * newCoords.y;
    vec2 newCoord2_x = hor2_brown * newCoords.x;
    vec2 newCoord2_y = ver2_brown * newCoords.y;
    if(abs(left_intensity_browndistance) > 0.001){       
        if (maskColor.b < 0.5) {
            out_texc += (newCoord_x + newCoord_y) * maskColor.a * left_intensity_browndistance * modify_intensity * left_scale_browndistance * smoothstep(0.5,0.48,maskColor.b);
        } 
    }

    if(abs(right_intensity_browndistance) > 0.001){
        if (maskColor.b > 0.5) {
           out_texc += (newCoord2_x + newCoord2_y) * maskColor.a * right_intensity_browndistance * modify_intensity * right_scale_browndistance * -1.0 * smoothstep(0.5,0.52,maskColor.b);
        }
    }

    maskColor = texture2D(tex_brownmask, texc + (out_texc - texc) / offset_wh.zw);
    maskColor = vec4(0.3,127.0 / 255.0,maskColor.a,maskColor.r);
    newCoords = (maskColor.rg - 127.0 / 255.0) / 25.0;
    newCoord_x = hor_brown * newCoords.x;
    newCoord_y = ver_brown * newCoords.y;
    newCoord2_x = hor2_brown * newCoords.x;
    newCoord2_y = ver2_brown * newCoords.y;
    if(abs(intensity_browndistance) > 0.001){
        if (maskColor.b < 0.5) {
            out_texc += (newCoord_x + newCoord_y) * maskColor.a * intensity_browndistance * modify_intensity * left_scale_browndistance;
        } else {
            out_texc += (newCoord2_x + newCoord2_y) * maskColor.a * intensity_browndistance * modify_intensity * -1.0 * right_scale_browndistance;
        }
    }
    
    return out_texc;
}

vec2 BrownTilt(vec2 texc_warp) {
    vec2 out_texc = texc_warp;

    vec2 off = abs(vec2(1.0) - texc_warp);
    vec2 off1 = abs(texc_warp);
    vec2 min_off = min(off, off1);
    vec2 modify_intensity = clamp(smoothstep(vec2(0.0), vec2(0.15, 0.1), min_off), vec2(0.55, 0.0), vec2(1.0, 1.0));

    vec4 maskColor = texture2D(tex_brownmask, texc + (out_texc - texc) / offset_wh.zw);
    maskColor.ba = vec2(maskColor.a,maskColor.r);
    if(abs(left_intensity_browntilt) > 0.001){       
        if (maskColor.b < 0.5) {
            vec2 tex_o = (left_M_browntilt * vec4(out_texc,0.0,1.0)).xy;
            out_texc += (tex_o - out_texc) * maskColor.a * modify_intensity * left_scale_browntilt * smoothstep(0.5,0.48,maskColor.b);
        } 
    }

    if(abs(right_intensity_browntilt) > 0.001){
        if (maskColor.b > 0.5) {
            vec2 tex_o = (right_M_browntilt * vec4(out_texc,0.0,1.0)).xy;
            out_texc += (tex_o - out_texc) * maskColor.a * modify_intensity * right_scale_browntilt * smoothstep(0.5,0.52,maskColor.b);
        }
    }

    maskColor = texture2D(tex_brownmask, texc + (out_texc - texc) / offset_wh.zw);
    maskColor.ba = vec2(maskColor.a,maskColor.r);
    if(abs(intensity_browntilt) > 0.001){
        if (maskColor.b < 0.5) {
            vec2 tex_o = (M_left_browntilt * vec4(out_texc,0.0,1.0)).xy;
            out_texc += (tex_o - out_texc) * maskColor.a * modify_intensity * left_scale_browntilt;
        } else {
            vec2 tex_o = (M_right_browntilt * vec4(out_texc,0.0,1.0)).xy;
            out_texc += (tex_o - out_texc) * maskColor.a * modify_intensity * right_scale_browntilt;
        }
    }
    
    return out_texc;
}

vec2 BrownLength(vec2 texc_warp) {
    vec2 out_texc = texc_warp;

    vec2 off = abs(vec2(1.0) - texc_warp);
    vec2 off1 = abs(texc_warp);
    vec2 min_off = min(off, off1);
    vec2 modify_intensity = clamp(smoothstep(vec2(0.0), vec2(0.15, 0.1), min_off), vec2(0.55, 0.0), vec2(1.0, 1.0));

    vec4 maskColor = texture2D(tex_brownlength, texc + (out_texc - texc) / offset_wh.zw);
    vec2 newCoords = (maskColor.rg - 127.0 / 255.0) / 25.0;
    vec2 newCoord_x = hor_brown * newCoords.x;
    vec2 newCoord_y = ver_brown * newCoords.y;
    vec2 newCoord2_x = hor2_brown * newCoords.x;
    vec2 newCoord2_y = ver2_brown * newCoords.y;
    if(abs(left_intensity_brownlength) > 0.001){       
        if (maskColor.b < 0.5) {
            out_texc += (newCoord_x + newCoord_y) * maskColor.a * left_intensity_brownlength * modify_intensity * left_scale_brownlength * smoothstep(0.5,0.48,maskColor.b);
        } 
    }

    if(abs(right_intensity_brownlength) > 0.001){
        if (maskColor.b > 0.5) {
           out_texc += (newCoord2_x + newCoord2_y) * maskColor.a * right_intensity_brownlength * modify_intensity * right_scale_brownlength * smoothstep(0.5,0.52,maskColor.b);
        }
    }

    maskColor = texture2D(tex_brownlength, texc + (out_texc - texc) / offset_wh.zw);
    newCoords = (maskColor.rg - 127.0 / 255.0) / 25.0;
    newCoord_x = hor_brown * newCoords.x;
    newCoord_y = ver_brown * newCoords.y;
    newCoord2_x = hor2_brown * newCoords.x;
    newCoord2_y = ver2_brown * newCoords.y;

    if(abs(intensity_brownlength) > 0.001){
        if (maskColor.b < 0.5) {
            out_texc += (newCoord_x + newCoord_y) * maskColor.a * intensity_brownlength * modify_intensity * left_scale_brownlength;
        } else {
            out_texc += (newCoord2_x + newCoord2_y) * maskColor.a * intensity_brownlength * modify_intensity * right_scale_brownlength;
        }
    }
    
    return out_texc;
}

void main(){
    vec2 out_texc = texc + texture2D(tex_uv_in, texc).rg;
    if (abs(intensity_browntilt) > 0.001 || abs(left_intensity_browntilt) > 0.001 || abs(right_intensity_browntilt) > 0.001) {
        out_texc = BrownTilt(out_texc);
    }
    if (abs(intensity_brownposition) > 0.001 || abs(left_intensity_brownposition) > 0.001 || abs(right_intensity_brownposition) > 0.001) {
        out_texc = BrownPosition(out_texc);
    }
    if (abs(intensity_browndistance) > 0.001 || abs(left_intensity_browndistance) > 0.001 || abs(right_intensity_browndistance) > 0.001) {
        out_texc = BrownDistance(out_texc);
    }
    if (abs(intensity_brownshape) > 0.001 || abs(left_intensity_brownshape) > 0.001 || abs(right_intensity_brownshape) > 0.001) {
        out_texc = BrownShape(out_texc);
    }
    if (abs(intensity_brownsize) > 0.001 || abs(left_intensity_brownsize) > 0.001 || abs(right_intensity_brownsize) > 0.001) {
        out_texc = BrownSize(out_texc);
    }
    if (abs(intensity_brownlength) > 0.001 || abs(left_intensity_brownlength) > 0.001 || abs(right_intensity_brownlength) > 0.001) {
        out_texc = BrownLength(out_texc);
    }
    gl_FragColor = vec4(out_texc - texc, 0.0, 1.0);
}