varying vec2 texc;

uniform vec2 ver_eye;
uniform vec2 hor_eye;
uniform vec2 ver2_eye;
uniform vec2 hor2_eye;
uniform vec4 offset_wh;

uniform float intensity_eyesize;
uniform float left_intensity_eyesize;
uniform float right_intensity_eyesize;
uniform float left_scale_eyesize;
uniform float right_scale_eyesize;
uniform sampler2D tex_eyesize;

uniform float intensity_eyewidth;
uniform float left_intensity_eyewidth;
uniform float right_intensity_eyewidth;
uniform float left_scale_eyewidth;
uniform float right_scale_eyewidth;
uniform sampler2D tex_eyewidth;

uniform float intensity_eyeheight;
uniform float left_intensity_eyeheight;
uniform float right_intensity_eyeheight;
uniform float left_scale_eyeheight;
uniform float right_scale_eyeheight;
uniform sampler2D tex_eyeheight;

uniform sampler2D tex_eyemask;
uniform float intensity_eyedistance;
uniform float left_intensity_eyedistance;
uniform float right_intensity_eyedistance;
uniform float left_scale_eyedistance;
uniform float right_scale_eyedistance;

uniform float intensity_eyeposition;
uniform float left_intensity_eyeposition;
uniform float right_intensity_eyeposition;
uniform float left_scale_eyeposition;
uniform float right_scale_eyeposition;

uniform float intensity_eyetilt;
uniform float left_intensity_eyetilt;
uniform float right_intensity_eyetilt;
uniform float left_scale_eyetilt;
uniform float right_scale_eyetilt;
uniform mat4 M_left_eyetilt;
uniform mat4 M_right_eyetilt;
uniform mat4 left_M_eyetilt;
uniform mat4 right_M_eyetilt;

uniform float intensity_eyetail;
uniform float left_intensity_eyetail;
uniform float right_intensity_eyetail;
uniform float left_scale_eyetail;
uniform float right_scale_eyetail;
uniform sampler2D tex_eyetail;

uniform float intensity_eyeunder;
uniform float left_intensity_eyeunder;
uniform float right_intensity_eyeunder;
uniform float left_scale_eyeunder;
uniform float right_scale_eyeunder;
uniform sampler2D tex_eyeunder;

uniform float intensity_eyepupil;
uniform float left_intensity_eyepupil;
uniform float right_intensity_eyepupil;
uniform float left_scale_eyepupil;
uniform float right_scale_eyepupil;
uniform mat4 left_ModelS_eyepupil;
uniform mat4 right_ModelS_eyepupil;
uniform float left_r_eyepupil;
uniform float right_r_eyepupil;
uniform vec2 left_center_eyepupil;
uniform vec2 right_center_eyepupil;
uniform vec2 wh_eyepupil;

uniform float intensity_eyeinner;
uniform float left_intensity_eyeinner;
uniform float right_intensity_eyeinner;
uniform float left_scale_eyeinner;
uniform float right_scale_eyeinner;
uniform sampler2D tex_eyeinner;

uniform float intensity_eyeouter;
uniform float left_intensity_eyeouter;
uniform float right_intensity_eyeouter;
uniform float left_scale_eyeouter;
uniform float right_scale_eyeouter;
uniform sampler2D tex_eyeouter;

uniform sampler2D tex_uv_in;

vec2 EyeSize(vec2 texc_warp) {
    vec2 out_texc = texc_warp;

    vec2 off = abs(vec2(1.0) - texc_warp);
    vec2 off1 = abs(texc_warp);
    vec2 min_off = min(off, off1);
    vec2 modify_intensity = clamp(smoothstep(vec2(0.0), vec2(0.15, 0.1), min_off), vec2(0.55, 0.0), vec2(1.0, 1.0));

    vec4 maskColor = texture2D(tex_eyesize, texc + (out_texc - texc) / offset_wh.zw);
    maskColor.a = smoothstep(0.05,1.0,maskColor.a);
    vec2 newCoords = (maskColor.rg - 127.0 / 255.0) / 25.0;
    vec2 newCoord_x = hor_eye * newCoords.x;
    vec2 newCoord_y = ver_eye * newCoords.y;
    vec2 newCoord2_x = hor2_eye * newCoords.x;
    vec2 newCoord2_y = ver2_eye * newCoords.y;
    if(abs(left_intensity_eyesize) > 0.001){       
        if (maskColor.b < 0.5) {
            out_texc += (newCoord_x + newCoord_y) * maskColor.a * left_intensity_eyesize * modify_intensity * left_scale_eyesize * smoothstep(0.5,0.48,maskColor.b);
        } 
    }

    if(abs(right_intensity_eyesize) > 0.001){
        if (maskColor.b > 0.5) {
           out_texc += (newCoord2_x + newCoord2_y) * maskColor.a * right_intensity_eyesize * modify_intensity * right_scale_eyesize * smoothstep(0.5,0.52,maskColor.b);
        }
    }

    maskColor = texture2D(tex_eyesize, texc + (out_texc - texc) / offset_wh.zw);
    maskColor.a = smoothstep(0.05,1.0,maskColor.a);
    newCoords = (maskColor.rg - 127.0 / 255.0) / 25.0;
    newCoord_x = hor_eye * newCoords.x;
    newCoord_y = ver_eye * newCoords.y;
    newCoord2_x = hor2_eye * newCoords.x;
    newCoord2_y = ver2_eye * newCoords.y;

    if(abs(intensity_eyesize) > 0.001){
        if (maskColor.b < 0.5) {
            out_texc += (newCoord_x + newCoord_y) * maskColor.a * intensity_eyesize * modify_intensity * left_scale_eyesize;
        } else {
            out_texc += (newCoord2_x + newCoord2_y) * maskColor.a * intensity_eyesize * modify_intensity * right_scale_eyesize;
        }
    }
    
    return out_texc;
}

vec2 EyeWidth(vec2 texc_warp) {
    vec2 out_texc = texc_warp;
    
    vec2 off = abs(vec2(1.0) - texc_warp);
    vec2 off1 = abs(texc_warp);
    vec2 min_off = min(off, off1);
    vec2 modify_intensity = clamp(smoothstep(vec2(0.0), vec2(0.15, 0.1), min_off), vec2(0.55, 0.0), vec2(1.0, 1.0));

    vec4 maskColor = texture2D(tex_eyewidth, texc + (out_texc - texc) / offset_wh.zw);
    maskColor.a = smoothstep(0.05,1.0,maskColor.a);
    vec2 newCoords = (maskColor.rg - 127.0 / 255.0) / 25.0;
    vec2 newCoord_x = hor_eye * newCoords.x;
    vec2 newCoord_y = ver_eye * newCoords.y;
    vec2 newCoord2_x = hor2_eye * newCoords.x;
    vec2 newCoord2_y = ver2_eye * newCoords.y;
    if(abs(left_intensity_eyewidth) > 0.001){       
        if (maskColor.b < 0.5) {
            out_texc += (newCoord_x + newCoord_y) * maskColor.a * left_intensity_eyewidth * modify_intensity * left_scale_eyewidth * smoothstep(0.5,0.48,maskColor.b);
        } 
    }

    if(abs(right_intensity_eyewidth) > 0.001){
        if (maskColor.b > 0.5) {
           out_texc += (newCoord2_x + newCoord2_y) * maskColor.a * right_intensity_eyewidth * modify_intensity * right_scale_eyewidth * smoothstep(0.5,0.52,maskColor.b);
        }
    }

    maskColor = texture2D(tex_eyewidth, texc + (out_texc - texc) / offset_wh.zw);
    maskColor.a = smoothstep(0.05,1.0,maskColor.a);
    newCoords = (maskColor.rg - 127.0 / 255.0) / 25.0;
    newCoord_x = hor_eye * newCoords.x;
    newCoord_y = ver_eye * newCoords.y;
    newCoord2_x = hor2_eye * newCoords.x;
    newCoord2_y = ver2_eye * newCoords.y;
    if(abs(intensity_eyewidth) > 0.001){
        if (maskColor.b < 0.5) {
            out_texc += (newCoord_x + newCoord_y) * maskColor.a * intensity_eyewidth * modify_intensity * left_scale_eyewidth;
        } else {
            out_texc += (newCoord2_x + newCoord2_y) * maskColor.a * intensity_eyewidth * modify_intensity * right_scale_eyewidth;
        }
    }
    
    return out_texc;
}

vec2 EyeDistance(vec2 texc_warp) {
    vec2 out_texc = texc_warp;

    vec2 off = abs(vec2(1.0) - texc_warp);
    vec2 off1 = abs(texc_warp);
    vec2 min_off = min(off, off1);
    vec2 modify_intensity = clamp(smoothstep(vec2(0.0), vec2(0.15, 0.1), min_off), vec2(0.55, 0.0), vec2(1.0, 1.0));

    vec4 maskColor = texture2D(tex_eyemask, texc + (out_texc - texc) / offset_wh.zw);
    maskColor = vec4(0.32,127.0 / 255.0,maskColor.a,maskColor.r);
    vec2 newCoords = (maskColor.rg - 127.0 / 255.0) / 25.0;
    vec2 newCoord_x = hor_eye * newCoords.x;
    vec2 newCoord_y = ver_eye * newCoords.y;
    vec2 newCoord2_x = hor2_eye * newCoords.x;
    vec2 newCoord2_y = ver2_eye * newCoords.y;
    if(abs(left_intensity_eyedistance) > 0.001){       
        if (maskColor.b < 0.5) {
            out_texc += (newCoord_x + newCoord_y) * maskColor.a * left_intensity_eyedistance * modify_intensity * left_scale_eyedistance * smoothstep(0.5,0.48,maskColor.b);
        } 
    }

    if(abs(right_intensity_eyedistance) > 0.001){
        if (maskColor.b > 0.5) {
           out_texc += (newCoord2_x + newCoord2_y) * maskColor.a * right_intensity_eyedistance * modify_intensity * -1.0 * right_scale_eyedistance * smoothstep(0.5,0.52,maskColor.b);
        }
    }

    maskColor = texture2D(tex_eyemask, texc + (out_texc - texc) / offset_wh.zw);
    maskColor = vec4(0.32,127.0 / 255.0,maskColor.a,maskColor.r);
    newCoords = (maskColor.rg - 127.0 / 255.0) / 25.0;
    newCoord_x = hor_eye * newCoords.x;
    newCoord_y = ver_eye * newCoords.y;
    newCoord2_x = hor2_eye * newCoords.x;
    newCoord2_y = ver2_eye * newCoords.y;
    if(abs(intensity_eyedistance) > 0.001){
        if (maskColor.b < 0.5) {
            out_texc += (newCoord_x + newCoord_y) * maskColor.a * intensity_eyedistance * modify_intensity * left_scale_eyedistance;
        } else {
            out_texc += (newCoord2_x + newCoord2_y) * maskColor.a * intensity_eyedistance * modify_intensity * -1.0 * right_scale_eyedistance;
        }
    }
    
    return out_texc;
}

vec2 EyePosition(vec2 texc_warp) {
    vec2 out_texc = texc_warp;

    vec2 off = abs(vec2(1.0) - texc_warp);
    vec2 off1 = abs(texc_warp);
    vec2 min_off = min(off, off1);
    vec2 modify_intensity = clamp(smoothstep(vec2(0.0), vec2(0.15, 0.1), min_off), vec2(0.55, 0.0), vec2(1.0, 1.0));

    vec4 maskColor = texture2D(tex_eyemask, texc + (out_texc - texc) / offset_wh.zw);
    maskColor = vec4(127.0 / 255.0,0.3,maskColor.a,maskColor.g);
    vec2 newCoords = (maskColor.rg - 127.0 / 255.0) / 25.0;
    vec2 newCoord_x = hor_eye * newCoords.x;
    vec2 newCoord_y = ver_eye * newCoords.y;
    vec2 newCoord2_x = hor2_eye * newCoords.x;
    vec2 newCoord2_y = ver2_eye * newCoords.y;
    if(abs(left_intensity_eyeposition) > 0.001){       
        if (maskColor.b < 0.5) {
            out_texc += (newCoord_x + newCoord_y) * maskColor.a * left_intensity_eyeposition * modify_intensity * left_scale_eyeposition * smoothstep(0.5,0.48,maskColor.b);
        } 
    }

    if(abs(right_intensity_eyeposition) > 0.001){
        if (maskColor.b > 0.5) {
           out_texc += (newCoord2_x + newCoord2_y) * maskColor.a * right_intensity_eyeposition * modify_intensity * right_scale_eyeposition * smoothstep(0.5,0.52,maskColor.b);
        }
    }

    maskColor = texture2D(tex_eyemask, texc + (out_texc - texc) / offset_wh.zw);
    maskColor = vec4(127.0 / 255.0,0.3,maskColor.a,maskColor.g);
    newCoords = (maskColor.rg - 127.0 / 255.0) / 25.0;
    newCoord_x = hor_eye * newCoords.x;
    newCoord_y = ver_eye * newCoords.y;
    newCoord2_x = hor2_eye * newCoords.x;
    newCoord2_y = ver2_eye * newCoords.y;
    if(abs(intensity_eyeposition) > 0.001){
        if (maskColor.b < 0.5) {
            out_texc += (newCoord_x + newCoord_y) * maskColor.a * intensity_eyeposition * modify_intensity * left_scale_eyeposition;
        } else {
            out_texc += (newCoord2_x + newCoord2_y) * maskColor.a * intensity_eyeposition * modify_intensity * right_scale_eyeposition;
        }
    }
    
    return out_texc;
}

vec2 EyeHeight(vec2 texc_warp) {
    vec2 out_texc = texc_warp;

    vec2 off = abs(vec2(1.0) - texc_warp);
    vec2 off1 = abs(texc_warp);
    vec2 min_off = min(off, off1);
    vec2 modify_intensity = clamp(smoothstep(vec2(0.0), vec2(0.15, 0.1), min_off), vec2(0.55, 0.0), vec2(1.0, 1.0));

    vec4 maskColor = texture2D(tex_eyeheight, texc + (out_texc - texc) / offset_wh.zw);
    maskColor.a = smoothstep(0.05,1.0,maskColor.a);
    vec2 newCoords = (maskColor.rg - 127.0 / 255.0) / 25.0;
    vec2 newCoord_x = hor_eye * newCoords.x;
    vec2 newCoord_y = ver_eye * newCoords.y;
    vec2 newCoord2_x = hor2_eye * newCoords.x;
    vec2 newCoord2_y = ver2_eye * newCoords.y;
    if(abs(left_intensity_eyeheight) > 0.001){       
        if (maskColor.b < 0.5) {
            out_texc += (newCoord_x + newCoord_y) * maskColor.a * left_intensity_eyeheight * modify_intensity * left_scale_eyeheight * smoothstep(0.5,0.48,maskColor.b);
        } 
    }

    if(abs(right_intensity_eyeheight) > 0.001){
        if (maskColor.b > 0.5) {
           out_texc += (newCoord2_x + newCoord2_y) * maskColor.a * right_intensity_eyeheight * modify_intensity * right_scale_eyeheight * smoothstep(0.5,0.52,maskColor.b);
        }
    }

    maskColor = texture2D(tex_eyeheight, texc + (out_texc - texc) / offset_wh.zw);
    maskColor.a = smoothstep(0.05,1.0,maskColor.a);
    newCoords = (maskColor.rg - 127.0 / 255.0) / 25.0;
    newCoord_x = hor_eye * newCoords.x;
    newCoord_y = ver_eye * newCoords.y;
    newCoord2_x = hor2_eye * newCoords.x;
    newCoord2_y = ver2_eye * newCoords.y;
    if(abs(intensity_eyeheight) > 0.001){
        if (maskColor.b < 0.5) {
            out_texc += (newCoord_x + newCoord_y) * maskColor.a * intensity_eyeheight * modify_intensity * left_scale_eyeheight;
        } else {
            out_texc += (newCoord2_x + newCoord2_y) * maskColor.a * intensity_eyeheight * modify_intensity * right_scale_eyeheight;
        }
    }
    
    return out_texc;
}

vec2 EyeTilt(vec2 texc_warp) {
    vec2 out_texc = texc_warp;

    vec2 off = abs(vec2(1.0) - texc_warp);
    vec2 off1 = abs(texc_warp);
    vec2 min_off = min(off, off1);
    vec2 modify_intensity = clamp(smoothstep(vec2(0.0), vec2(0.15, 0.1), min_off), vec2(0.55, 0.0), vec2(1.0, 1.0));

    vec4 maskColor = texture2D(tex_eyemask, texc + (out_texc - texc) / offset_wh.zw);
    maskColor.ba = vec2(maskColor.a,maskColor.b);
    if(abs(left_intensity_eyetilt) > 0.001){       
        if (maskColor.b < 0.5) {
            vec2 tex_o = (left_M_eyetilt * vec4(out_texc,0.0,1.0)).xy;
            out_texc += (tex_o - out_texc) * maskColor.a * modify_intensity * left_scale_eyetilt * smoothstep(0.5,0.48,maskColor.b);
        } 
    }

    if(abs(right_intensity_eyetilt) > 0.001){
        if (maskColor.b > 0.5) {
            vec2 tex_o = (right_M_eyetilt * vec4(out_texc,0.0,1.0)).xy;
            out_texc += (tex_o - out_texc) * maskColor.a * modify_intensity * right_scale_eyetilt * smoothstep(0.5,0.52,maskColor.b);
        }
    }

    maskColor = texture2D(tex_eyemask, texc + (out_texc - texc) / offset_wh.zw);
    maskColor.ba = vec2(maskColor.a,maskColor.b);
    if(abs(intensity_eyetilt) > 0.001){
        if (maskColor.b < 0.5) {
            vec2 tex_o = (M_left_eyetilt * vec4(out_texc,0.0,1.0)).xy;
            out_texc += (tex_o - out_texc) * maskColor.a * modify_intensity * left_scale_eyetilt;
        } else {
            vec2 tex_o = (M_right_eyetilt * vec4(out_texc,0.0,1.0)).xy;
            out_texc += (tex_o - out_texc) * maskColor.a * modify_intensity * right_scale_eyetilt;
        }
    }
    
    return out_texc;
}

vec2 EyeTail(vec2 texc_warp) {
    vec2 out_texc = texc_warp;

    vec2 off = abs(vec2(1.0) - texc_warp);
    vec2 off1 = abs(texc_warp);
    vec2 min_off = min(off, off1);
    vec2 modify_intensity = clamp(smoothstep(vec2(0.0), vec2(0.15, 0.1), min_off), vec2(0.55, 0.0), vec2(1.0, 1.0));

    vec4 maskColor = texture2D(tex_eyetail, texc + (out_texc - texc) / offset_wh.zw);
    maskColor.a = smoothstep(0.05,1.0,maskColor.a);
    vec2 newCoords = (maskColor.rg - 127.0 / 255.0) / 25.0;
    vec2 newCoord_x = hor_eye * newCoords.x;
    vec2 newCoord_y = ver_eye * newCoords.y;
    vec2 newCoord2_x = hor2_eye * newCoords.x;
    vec2 newCoord2_y = ver2_eye * newCoords.y;
    if(abs(left_intensity_eyetail) > 0.001){       
        if (maskColor.b < 0.5) {
            out_texc += (newCoord_x + newCoord_y) * maskColor.a * left_intensity_eyetail * modify_intensity * left_scale_eyetail * smoothstep(0.5,0.48,maskColor.b);
        } 
    }

    if(abs(right_intensity_eyetail) > 0.001){
        if (maskColor.b > 0.5) {
           out_texc += (newCoord2_x + newCoord2_y) * maskColor.a * right_intensity_eyetail * modify_intensity * right_scale_eyetail * smoothstep(0.5,0.52,maskColor.b);
        }
    }

    maskColor = texture2D(tex_eyetail, texc + (out_texc - texc) / offset_wh.zw);
    maskColor.a = smoothstep(0.05,1.0,maskColor.a);
    newCoords = (maskColor.rg - 127.0 / 255.0) / 25.0;
    newCoord_x = hor_eye * newCoords.x;
    newCoord_y = ver_eye * newCoords.y;
    newCoord2_x = hor2_eye * newCoords.x;
    newCoord2_y = ver2_eye * newCoords.y;
    if(abs(intensity_eyetail) > 0.001){
        if (maskColor.b < 0.5) {
            out_texc += (newCoord_x + newCoord_y) * maskColor.a * intensity_eyetail * modify_intensity * left_scale_eyetail;
        } else {
            out_texc += (newCoord2_x + newCoord2_y) * maskColor.a * intensity_eyetail * modify_intensity * right_scale_eyetail;
        }
    }
    
    return out_texc;
}

vec2 EyeUnder(vec2 texc_warp) {
    vec2 out_texc = texc_warp;
    
    vec2 off = abs(vec2(1.0) - texc_warp);
    vec2 off1 = abs(texc_warp);
    vec2 min_off = min(off, off1);
    vec2 modify_intensity = clamp(smoothstep(vec2(0.0), vec2(0.15, 0.1), min_off), vec2(0.55, 0.0), vec2(1.0, 1.0));

    vec4 maskColor = texture2D(tex_eyeunder, texc + (out_texc - texc) / offset_wh.zw);
    maskColor.a = smoothstep(0.05,1.0,maskColor.a);
    vec2 newCoords = (maskColor.rg - 127.0 / 255.0) / 25.0;
    vec2 newCoord_x = hor_eye * newCoords.x;
    vec2 newCoord_y = ver_eye * newCoords.y;
    vec2 newCoord2_x = hor2_eye * newCoords.x;
    vec2 newCoord2_y = ver2_eye * newCoords.y;
    if(abs(left_intensity_eyeunder) > 0.001){       
        if (maskColor.b < 0.5) {
            out_texc += (newCoord_x + newCoord_y) * maskColor.a * left_intensity_eyeunder * modify_intensity * left_scale_eyeunder * smoothstep(0.5,0.48,maskColor.b);
        } 
    }

    if(abs(right_intensity_eyeunder) > 0.001){
        if (maskColor.b > 0.5) {
           out_texc += (newCoord2_x + newCoord2_y) * maskColor.a * right_intensity_eyeunder * modify_intensity * right_scale_eyeunder * smoothstep(0.5,0.52,maskColor.b);
        }
    }

    maskColor = texture2D(tex_eyeunder, texc + (out_texc - texc) / offset_wh.zw);
    maskColor.a = smoothstep(0.05,1.0,maskColor.a);
    newCoords = (maskColor.rg - 127.0 / 255.0) / 25.0;
    newCoord_x = hor_eye * newCoords.x;
    newCoord_y = ver_eye * newCoords.y;
    newCoord2_x = hor2_eye * newCoords.x;
    newCoord2_y = ver2_eye * newCoords.y;
    if(abs(intensity_eyeunder) > 0.001){
        if (maskColor.b < 0.5) {
            out_texc += (newCoord_x + newCoord_y) * maskColor.a * intensity_eyeunder * modify_intensity * left_scale_eyeunder;
        } else {
            out_texc += (newCoord2_x + newCoord2_y) * maskColor.a * intensity_eyeunder * modify_intensity * right_scale_eyeunder;
        }
    }
    
    return out_texc;
}

vec2 EyePupil(vec2 texc_warp) {
    vec2 out_texc = texc_warp;  

    vec2 off = abs(vec2(1.0) - texc_warp);
    vec2 off1 = abs(texc_warp);
    vec2 min_off = min(off, off1);
    vec2 modify_intensity = clamp(smoothstep(vec2(0.0), vec2(0.15, 0.1), min_off), vec2(0.55, 0.0), vec2(1.0, 1.0));

    vec4 maskColor = texture2D(tex_eyemask, texc + (out_texc - texc) / offset_wh.zw);
    maskColor.ba = vec2(maskColor.a,smoothstep(0.4,1.0,maskColor.r));
    if(abs(left_intensity_eyepupil) > 0.001){       
        if (maskColor.b < 0.5) {
            vec2 tex_o = (left_ModelS_eyepupil * vec4(out_texc,0.0,1.0)).xy;
            float dis = distance(out_texc * wh_eyepupil, left_center_eyepupil);
            float alpha = smoothstep(2.8, 0.1, dis / left_r_eyepupil);
            out_texc += (tex_o - out_texc) * maskColor.a * left_intensity_eyepupil * modify_intensity * left_scale_eyepupil * smoothstep(0.5,0.48,maskColor.b) * alpha;
        } 
    }

    if(abs(right_intensity_eyepupil) > 0.001){
        if (maskColor.b > 0.5) {
            vec2 tex_o = (right_ModelS_eyepupil * vec4(out_texc,0.0,1.0)).xy;
            float dis = distance(out_texc * wh_eyepupil, right_center_eyepupil);
            float alpha = smoothstep(2.8, 0.1, dis / right_r_eyepupil);
            out_texc += (tex_o - out_texc) * maskColor.a * right_intensity_eyepupil * modify_intensity * right_scale_eyepupil * smoothstep(0.5,0.52,maskColor.b) * alpha;
        }
    }

    maskColor = texture2D(tex_eyemask, texc + (out_texc - texc) / offset_wh.zw);
    maskColor.ba = vec2(maskColor.a,smoothstep(0.4,1.0,maskColor.r));
    if(abs(intensity_eyepupil) > 0.001){
        if (maskColor.b < 0.5) {
            vec2 tex_o = (left_ModelS_eyepupil * vec4(out_texc,0.0,1.0)).xy;
            float dis = distance(out_texc * wh_eyepupil, left_center_eyepupil);
            float alpha = smoothstep(2.8, 0.1, dis / left_r_eyepupil);
            out_texc += (tex_o - out_texc) * maskColor.a * intensity_eyepupil * modify_intensity * left_scale_eyepupil * alpha;
        } else {
            vec2 tex_o = (right_ModelS_eyepupil * vec4(out_texc,0.0,1.0)).xy;
            float dis = distance(out_texc * wh_eyepupil, right_center_eyepupil);
            float alpha = smoothstep(2.8, 0.1, dis / right_r_eyepupil);
            out_texc += (tex_o - out_texc) * maskColor.a * intensity_eyepupil * modify_intensity * right_scale_eyepupil * alpha;
        }
    }
    
    return out_texc;
}

vec2 EyeInner(vec2 texc_warp) {
    vec2 out_texc = texc_warp;

    vec2 off = abs(vec2(1.0) - texc_warp);
    vec2 off1 = abs(texc_warp);
    vec2 min_off = min(off, off1);
    vec2 modify_intensity = clamp(smoothstep(vec2(0.0), vec2(0.15, 0.1), min_off), vec2(0.55, 0.0), vec2(1.0, 1.0));

    vec4 maskColor = texture2D(tex_eyeinner, texc + (out_texc - texc) / offset_wh.zw);
    maskColor.a = smoothstep(0.05,1.0,maskColor.a);
    vec2 newCoords = (maskColor.rg - 127.0 / 255.0) / 25.0;
    vec2 newCoord_x = hor_eye * newCoords.x;
    vec2 newCoord_y = ver_eye * newCoords.y;
    vec2 newCoord2_x = hor2_eye * newCoords.x;
    vec2 newCoord2_y = ver2_eye * newCoords.y;
    if(abs(left_intensity_eyeinner) > 0.001){       
        if (maskColor.b < 0.5) {
            out_texc += (newCoord_x + newCoord_y) * maskColor.a * left_intensity_eyeinner * modify_intensity * left_scale_eyeinner * smoothstep(0.5,0.48,maskColor.b);
        } 
    }

    if(abs(right_intensity_eyeinner) > 0.001){
        if (maskColor.b > 0.5) {
           out_texc += (newCoord2_x + newCoord2_y) * maskColor.a * right_intensity_eyeinner * modify_intensity * right_scale_eyeinner * smoothstep(0.5,0.52,maskColor.b);
        }
    }

    maskColor = texture2D(tex_eyeinner, texc + (out_texc - texc) / offset_wh.zw);
    maskColor.a = smoothstep(0.05,1.0,maskColor.a);
    newCoords = (maskColor.rg - 127.0 / 255.0) / 25.0;
    newCoord_x = hor_eye * newCoords.x;
    newCoord_y = ver_eye * newCoords.y;
    newCoord2_x = hor2_eye * newCoords.x;
    newCoord2_y = ver2_eye * newCoords.y;
    if(abs(intensity_eyeinner) > 0.001){
        if (maskColor.b < 0.5) {
            out_texc += (newCoord_x + newCoord_y) * maskColor.a * intensity_eyeinner * modify_intensity * left_scale_eyeinner;
        } else {
            out_texc += (newCoord2_x + newCoord2_y) * maskColor.a * intensity_eyeinner * modify_intensity * right_scale_eyeinner;
        }
    }
    
    return out_texc;
}

vec2 EyeOuter(vec2 texc_warp) {
    vec2 out_texc = texc_warp;

    vec2 off = abs(vec2(1.0) - texc_warp);
    vec2 off1 = abs(texc_warp);
    vec2 min_off = min(off, off1);
    vec2 modify_intensity = clamp(smoothstep(vec2(0.0), vec2(0.15, 0.1), min_off), vec2(0.55, 0.0), vec2(1.0, 1.0));

    vec4 maskColor = texture2D(tex_eyeouter, texc + (out_texc - texc) / offset_wh.zw);
    maskColor.a = smoothstep(0.05,1.0,maskColor.a);
    vec2 newCoords = (maskColor.rg - 127.0 / 255.0) / 25.0;
    vec2 newCoord_x = hor_eye * newCoords.x;
    vec2 newCoord_y = ver_eye * newCoords.y;
    vec2 newCoord2_x = hor2_eye * newCoords.x;
    vec2 newCoord2_y = ver2_eye * newCoords.y;
    if(abs(left_intensity_eyeouter) > 0.001){       
        if (maskColor.b < 0.5) {
            out_texc += (newCoord_x + newCoord_y) * maskColor.a * left_intensity_eyeouter * modify_intensity * left_scale_eyeouter * smoothstep(0.5,0.48,maskColor.b);
        } 
    }

    if(abs(right_intensity_eyeouter) > 0.001){
        if (maskColor.b > 0.5) {
           out_texc += (newCoord2_x + newCoord2_y) * maskColor.a * right_intensity_eyeouter * modify_intensity * right_scale_eyeouter * smoothstep(0.5,0.52,maskColor.b);
        }
    }

    maskColor = texture2D(tex_eyeouter, texc + (out_texc - texc) / offset_wh.zw);
    maskColor.a = smoothstep(0.05,1.0,maskColor.a);
    newCoords = (maskColor.rg - 127.0 / 255.0) / 25.0;
    newCoord_x = hor_eye * newCoords.x;
    newCoord_y = ver_eye * newCoords.y;
    newCoord2_x = hor2_eye * newCoords.x;
    newCoord2_y = ver2_eye * newCoords.y;
    if(abs(intensity_eyeouter) > 0.001){
        if (maskColor.b < 0.5) {
            out_texc += (newCoord_x + newCoord_y) * maskColor.a * intensity_eyeouter * modify_intensity * left_scale_eyeouter;
        } else {
            out_texc += (newCoord2_x + newCoord2_y) * maskColor.a * intensity_eyeouter * modify_intensity * right_scale_eyeouter;
        }
    }
    
    return out_texc;
}

void main(){
    vec2 out_texc = texc + texture2D(tex_uv_in, texc).rg;
    if (abs(intensity_eyetilt) > 0.001 || abs(left_intensity_eyetilt) > 0.001 || abs(right_intensity_eyetilt) > 0.001) {
        out_texc = EyeTilt(out_texc);
    }
    if (abs(intensity_eyeposition) > 0.001 || abs(left_intensity_eyeposition) > 0.001 || abs(right_intensity_eyeposition) > 0.001) {
        out_texc = EyePosition(out_texc);
    }
    if (abs(intensity_eyedistance) > 0.001 || abs(left_intensity_eyedistance) > 0.001 || abs(right_intensity_eyedistance) > 0.001) {
        out_texc = EyeDistance(out_texc);
    }
    if (abs(intensity_eyesize) > 0.001 || abs(left_intensity_eyesize) > 0.001 || abs(right_intensity_eyesize) > 0.001) {
        out_texc = EyeSize(out_texc);
    }
    if (abs(intensity_eyepupil) > 0.001 || abs(left_intensity_eyepupil) > 0.001 || abs(right_intensity_eyepupil) > 0.001) {
        out_texc = EyePupil(out_texc);
    }
    if (abs(intensity_eyewidth) > 0.001 || abs(left_intensity_eyewidth) > 0.001 || abs(right_intensity_eyewidth) > 0.001) {
        out_texc = EyeWidth(out_texc);
    }
    if (abs(intensity_eyeheight) > 0.001 || abs(left_intensity_eyeheight) > 0.001 || abs(right_intensity_eyeheight) > 0.001) {
        out_texc = EyeHeight(out_texc);
    }
    if (abs(intensity_eyetail) > 0.001 || abs(left_intensity_eyetail) > 0.001 || abs(right_intensity_eyetail) > 0.001) {
        out_texc = EyeTail(out_texc);
    }
    if (abs(intensity_eyeunder) > 0.001 || abs(left_intensity_eyeunder) > 0.001 || abs(right_intensity_eyeunder) > 0.001) {
        out_texc = EyeUnder(out_texc);
    }
    if (abs(intensity_eyeinner) > 0.001 || abs(left_intensity_eyeinner) > 0.001 || abs(right_intensity_eyeinner) > 0.001) {
        out_texc = EyeInner(out_texc);
    }
    if (abs(intensity_eyeouter) > 0.001 || abs(left_intensity_eyeouter) > 0.001 || abs(right_intensity_eyeouter) > 0.001) {
        out_texc = EyeOuter(out_texc);
    }
    gl_FragColor = vec4(out_texc - texc, 0.0, 1.0);
}