varying vec2 texc;
uniform vec2 ver_face;
uniform vec2 hor_face;
uniform vec4 offset_wh;

uniform float intensity_facev;
uniform float left_intensity_facev;
uniform float right_intensity_facev;
uniform float left_scale_facev;
uniform float right_scale_facev;
uniform sampler2D tex_facev;

uniform float intensity_facesmall;
uniform float scale_facesmall;
uniform sampler2D tex_facesmall;

uniform float intensity_headsmall;
uniform float scale_headsmall;
uniform vec2 ver_headsmall;
uniform vec2 hor_headsmall;
uniform sampler2D tex_headsmall;

uniform float intensity_facewidth;
uniform float left_intensity_facewidth;
uniform float right_intensity_facewidth;
uniform float left_scale_facewidth;
uniform float right_scale_facewidth;
uniform sampler2D tex_facewidth;

uniform float intensity_facelength;
uniform float scale_facelength;
uniform sampler2D tex_facelength;

uniform float intensity_jaw;
uniform float left_intensity_jaw;
uniform float right_intensity_jaw;
uniform float left_scale_jaw;
uniform float right_scale_jaw;
uniform sampler2D tex_jaw;

uniform float intensity_cheekbone;
uniform float left_intensity_cheekbone;
uniform float right_intensity_cheekbone;
uniform float left_scale_cheekbone;
uniform float right_scale_cheekbone;
uniform sampler2D tex_cheekbone;

uniform float intensity_temple;
uniform float left_intensity_temple;
uniform float right_intensity_temple;
uniform float left_scale_temple;
uniform float right_scale_temple;
uniform sampler2D tex_temple;

uniform float intensity_hairline;
uniform float scale_hairline;
uniform sampler2D tex_hairline;

uniform sampler2D tex_uv_in;

vec2 FaceV(vec2 texc_warp) {
    vec2 out_texc = texc_warp;

    vec2 off = abs(vec2(1.0) - texc_warp);
    vec2 off1 = abs(texc_warp);
    vec2 min_off = min(off, off1);
    vec2 modify_intensity = clamp(smoothstep(vec2(0.0), vec2(0.15, 0.1), min_off), vec2(0.55, 0.0), vec2(1.0, 1.0));

    vec4 maskColor = texture2D(tex_facev, texc + (out_texc - texc) / offset_wh.zw);
    vec2 newCoords = (maskColor.rg - 127.0 / 255.0) / 50.0;
    vec2 newCoord_x = hor_face * newCoords.x;
    vec2 newCoord_y = ver_face * newCoords.y;
    if(abs(left_intensity_facev) > 0.001){       
        if (maskColor.b < 0.5) {
            out_texc += (newCoord_x + newCoord_y) * maskColor.a * left_intensity_facev * modify_intensity * left_scale_facev * smoothstep(0.5,0.48,maskColor.b);
        } 
    }

    if(abs(right_intensity_facev) > 0.001){
        if (maskColor.b > 0.5) {
           out_texc += (newCoord_x + newCoord_y) * maskColor.a * right_intensity_facev * modify_intensity * right_scale_facev * smoothstep(0.5,0.52,maskColor.b);
        }
    }

    maskColor = texture2D(tex_facev, texc + (out_texc - texc) / offset_wh.zw);
    newCoords = (maskColor.rg - 127.0 / 255.0) / 50.0;
    newCoord_x = hor_face * newCoords.x;
    newCoord_y = ver_face * newCoords.y;
    if(abs(intensity_facev) > 0.001){
        if (maskColor.b < 0.5) {
            out_texc += (newCoord_x + newCoord_y) * maskColor.a * intensity_facev * modify_intensity * left_scale_facev;
        } else {
            out_texc += (newCoord_x + newCoord_y) * maskColor.a * intensity_facev * modify_intensity * right_scale_facev;
        }
    }
    
    return out_texc;
}

vec2 FaceSmall(vec2 texc_warp) {
    vec2 out_texc = texc_warp;
    vec4 maskColor = texture2D(tex_facesmall, texc + (out_texc - texc) / offset_wh.zw);
    vec2 newCoords = (maskColor.rg - 127.0 / 255.0) / 50.0;

    vec2 off = abs(vec2(1.0) - texc_warp);
    vec2 off1 = abs(texc_warp);
    vec2 min_off = min(off, off1);
    vec2 modify_intensity = clamp(smoothstep(vec2(0.0), vec2(0.15, 0.1), min_off), vec2(0.55, 0.0), vec2(1.0, 1.0));

    vec2 newCoord_x = hor_face * newCoords.x;
    vec2 newCoord_y = ver_face * newCoords.y;
    if(intensity_facesmall > 0.0){
        maskColor.a = 1.0;
    }else{
        newCoord_y -= ver_face * smoothstep(0.75,0.6,maskColor.a) * 0.0025;
    }

    if(abs(intensity_facesmall) > 0.001){
        out_texc += (newCoord_x + newCoord_y) * maskColor.a * intensity_facesmall * modify_intensity * scale_facesmall;
    }
    
    return out_texc;
}

vec2 HeadSmall(vec2 texc_warp) {
    vec2 out_texc = texc_warp;
    vec4 maskColor = texture2D(tex_headsmall, texc + (out_texc - texc) / offset_wh.zw);
    vec2 newCoords = (maskColor.rg - 127.0 / 255.0) / 50.0;

    vec2 off = abs(vec2(1.0) - texc_warp);
    vec2 off1 = abs(texc_warp);
    vec2 min_off = min(off, off1);
    vec2 modify_intensity = clamp(smoothstep(vec2(0.0), vec2(0.15, 0.1), min_off), vec2(0.55, 0.0), vec2(1.0, 1.0));

    vec2 newCoord_x = hor_headsmall * newCoords.x;
    vec2 newCoord_y = ver_headsmall * newCoords.y;

    if(abs(intensity_headsmall) > 0.001){
        out_texc += (newCoord_x + newCoord_y) * maskColor.a * intensity_headsmall * modify_intensity * scale_headsmall;
    }
    
    return out_texc;
}

vec2 FaceWidth(vec2 texc_warp) {
    vec2 out_texc = texc_warp;

    vec2 off = abs(vec2(1.0) - texc_warp);
    vec2 off1 = abs(texc_warp);
    vec2 min_off = min(off, off1);
    vec2 modify_intensity = clamp(smoothstep(vec2(0.0), vec2(0.15, 0.1), min_off), vec2(0.55, 0.0), vec2(1.0, 1.0));

    vec4 maskColor = texture2D(tex_facewidth, texc + (out_texc - texc) / offset_wh.zw);
    vec2 newCoords = (maskColor.rg - 127.0 / 255.0) / 25.0;
    vec2 newCoord_x = hor_face * newCoords.x;
    vec2 newCoord_y = ver_face * newCoords.y;
    if(abs(left_intensity_facewidth) > 0.001){       
        if (maskColor.b < 0.5) {
            out_texc += (newCoord_x + newCoord_y) * maskColor.a * left_intensity_facewidth * modify_intensity * left_scale_facewidth * smoothstep(0.5,0.48,maskColor.b);
        } 
    }

    if(abs(right_intensity_facewidth) > 0.001){
        if (maskColor.b > 0.5) {
           out_texc += (newCoord_x + newCoord_y) * maskColor.a * right_intensity_facewidth * modify_intensity * right_scale_facewidth * smoothstep(0.5,0.52,maskColor.b);
        }
    }

    maskColor = texture2D(tex_facewidth, texc + (out_texc - texc) / offset_wh.zw);
    newCoords = (maskColor.rg - 127.0 / 255.0) / 25.0;
    newCoord_x = hor_face * newCoords.x;
    newCoord_y = ver_face * newCoords.y;
    if(abs(intensity_facewidth) > 0.001){
        if (maskColor.b < 0.5) {
            out_texc += (newCoord_x + newCoord_y) * maskColor.a * intensity_facewidth * modify_intensity * left_scale_facewidth;
        } else {
            out_texc += (newCoord_x + newCoord_y) * maskColor.a * intensity_facewidth * modify_intensity * right_scale_facewidth;
        }
    }
    
    return out_texc;
}

vec2 FaceLength(vec2 texc_warp) {
    vec2 out_texc = texc_warp;
    vec4 maskColor = texture2D(tex_facelength, texc + (out_texc - texc) / offset_wh.zw);
    vec2 newCoords = (maskColor.rg - 127.0 / 255.0) / 25.0;

    vec2 off = abs(vec2(1.0) - texc_warp);
    vec2 off1 = abs(texc_warp);
    vec2 min_off = min(off, off1);
    vec2 modify_intensity = clamp(smoothstep(vec2(0.0), vec2(0.15, 0.1), min_off), vec2(0.55, 0.0), vec2(1.0, 1.0));

    vec2 newCoord_x = hor_face * newCoords.x;
    vec2 newCoord_y = ver_face * newCoords.y;
    if(intensity_facelength > 0.0){
        maskColor.a = 1.0;
    }else{
        maskColor.a = clamp(maskColor.a * 1.1, 0.0, 1.0);
    }

    if(abs(intensity_facelength) > 0.001){
        out_texc += (newCoord_x + newCoord_y) * maskColor.a * intensity_facelength * modify_intensity * scale_facelength;
    }
    
    return out_texc;
}

vec2 Jaw(vec2 texc_warp) {
    vec2 out_texc = texc_warp;
    
    vec2 off = abs(vec2(1.0) - texc_warp);
    vec2 off1 = abs(texc_warp);
    vec2 min_off = min(off, off1);
    vec2 modify_intensity = clamp(smoothstep(vec2(0.0), vec2(0.15, 0.1), min_off), vec2(0.55, 0.0), vec2(1.0, 1.0));

    vec4 maskColor = texture2D(tex_jaw, texc + (out_texc - texc) / offset_wh.zw);
    vec2 newCoords = (maskColor.rg - 127.0 / 255.0) / 25.0;
    vec2 newCoord_x = hor_face * newCoords.x;
    vec2 newCoord_y = ver_face * newCoords.y;
    if(abs(left_intensity_jaw) > 0.001){       
        if (maskColor.b < 0.5) {
            out_texc += (newCoord_x + newCoord_y) * maskColor.a * left_intensity_jaw * modify_intensity * left_scale_jaw * smoothstep(0.5,0.48,maskColor.b);
        } 
    }

    if(abs(right_intensity_jaw) > 0.001){
        if (maskColor.b > 0.5) {
           out_texc += (newCoord_x + newCoord_y) * maskColor.a * right_intensity_jaw * modify_intensity * right_scale_jaw * smoothstep(0.5,0.52,maskColor.b);
        }
    }

    maskColor = texture2D(tex_jaw, texc + (out_texc - texc) / offset_wh.zw);
    newCoords = (maskColor.rg - 127.0 / 255.0) / 25.0;
    newCoord_x = hor_face * newCoords.x;
    newCoord_y = ver_face * newCoords.y;
    if(abs(intensity_jaw) > 0.001){
        if (maskColor.b < 0.5) {
            out_texc += (newCoord_x + newCoord_y) * maskColor.a * intensity_jaw * modify_intensity * left_scale_jaw;
        } else {
            out_texc += (newCoord_x + newCoord_y) * maskColor.a * intensity_jaw * modify_intensity * right_scale_jaw;
        }
    }
    
    return out_texc;
}

vec2 Cheekbone(vec2 texc_warp) {
    vec2 out_texc = texc_warp;

    vec2 off = abs(vec2(1.0) - texc_warp);
    vec2 off1 = abs(texc_warp);
    vec2 min_off = min(off, off1);
    vec2 modify_intensity = clamp(smoothstep(vec2(0.0), vec2(0.15, 0.1), min_off), vec2(0.55, 0.0), vec2(1.0, 1.0));

    vec4 maskColor = texture2D(tex_cheekbone, texc + (out_texc - texc) / offset_wh.zw);
    vec2 newCoords = (maskColor.rg - 127.0 / 255.0) / 25.0;
    vec2 newCoord_x = hor_face * newCoords.x;
    vec2 newCoord_y = ver_face * newCoords.y;
    if(abs(left_intensity_cheekbone) > 0.001){       
        if (maskColor.b < 0.5) {
            out_texc += (newCoord_x + newCoord_y) * maskColor.a * left_intensity_cheekbone * modify_intensity * left_scale_cheekbone * smoothstep(0.5,0.48,maskColor.b);
        } 
    }

    if(abs(right_intensity_cheekbone) > 0.001){
        if (maskColor.b > 0.5) {
           out_texc += (newCoord_x + newCoord_y) * maskColor.a * right_intensity_cheekbone * modify_intensity * right_scale_cheekbone * smoothstep(0.5,0.52,maskColor.b);
        }
    }

    maskColor = texture2D(tex_cheekbone, texc + (out_texc - texc) / offset_wh.zw);
    newCoords = (maskColor.rg - 127.0 / 255.0) / 25.0;
    newCoord_x = hor_face * newCoords.x;
    newCoord_y = ver_face * newCoords.y;
    if(abs(intensity_cheekbone) > 0.001){
        if (maskColor.b < 0.5) {
            out_texc += (newCoord_x + newCoord_y) * maskColor.a * intensity_cheekbone * modify_intensity * left_scale_cheekbone;
        } else {
            out_texc += (newCoord_x + newCoord_y) * maskColor.a * intensity_cheekbone * modify_intensity * right_scale_cheekbone;
        }
    }
    
    return out_texc;
}

vec2 Temple(vec2 texc_warp) {
    vec2 out_texc = texc_warp;

    vec2 off = abs(vec2(1.0) - texc_warp);
    vec2 off1 = abs(texc_warp);
    vec2 min_off = min(off, off1);
    vec2 modify_intensity = clamp(smoothstep(vec2(0.0), vec2(0.15, 0.1), min_off), vec2(0.55, 0.0), vec2(1.0, 1.0));

    vec4 maskColor = texture2D(tex_temple, texc + (out_texc - texc) / offset_wh.zw);
    vec2 newCoords = (maskColor.rg - 127.0 / 255.0) / 25.0;
    vec2 newCoord_x = hor_face * newCoords.x;
    vec2 newCoord_y = ver_face * newCoords.y;
    if(abs(left_intensity_temple) > 0.001){       
        if (maskColor.b < 0.5) {
            out_texc += (newCoord_x + newCoord_y) * maskColor.a * left_intensity_temple * modify_intensity * left_scale_temple * smoothstep(0.5,0.48,maskColor.b);
        } 
    }

    if(abs(right_intensity_temple) > 0.001){
        if (maskColor.b > 0.5) {
           out_texc += (newCoord_x + newCoord_y) * maskColor.a * right_intensity_temple * modify_intensity * right_scale_temple * smoothstep(0.5,0.52,maskColor.b);
        }
    }

    maskColor = texture2D(tex_temple, texc + (out_texc - texc) / offset_wh.zw);
    newCoords = (maskColor.rg - 127.0 / 255.0) / 25.0;
    newCoord_x = hor_face * newCoords.x;
    newCoord_y = ver_face * newCoords.y;
    if(abs(intensity_temple) > 0.001){
        if (maskColor.b < 0.5) {
            out_texc += (newCoord_x + newCoord_y) * maskColor.a * intensity_temple * modify_intensity * left_scale_temple;
        } else {
            out_texc += (newCoord_x + newCoord_y) * maskColor.a * intensity_temple * modify_intensity * right_scale_temple;
        }
    }
    
    return out_texc;
}

vec2 Hairline(vec2 texc_warp) {
    vec2 out_texc = texc_warp;
    vec4 maskColor = texture2D(tex_hairline, texc + (out_texc - texc) / offset_wh.zw);
    vec2 newCoords = (maskColor.rg - 127.0 / 255.0) / 25.0;

    vec2 off = abs(vec2(1.0) - texc_warp);
    vec2 off1 = abs(texc_warp);
    vec2 min_off = min(off, off1);
    vec2 modify_intensity = clamp(smoothstep(vec2(0.0), vec2(0.15, 0.1), min_off), vec2(0.55, 0.0), vec2(1.0, 1.0));

    vec2 newCoord_x = hor_face * newCoords.x;
    vec2 newCoord_y = ver_face * newCoords.y;

    if(abs(intensity_hairline) > 0.001){
        out_texc += (newCoord_x + newCoord_y) * maskColor.a * intensity_hairline * modify_intensity * scale_hairline;
    }
    
    return out_texc;
}

void main(){
    vec2 out_texc = texc + texture2D(tex_uv_in, texc).rg;
    if (abs(intensity_facev) > 0.001 || abs(left_intensity_facev) > 0.001 || abs(right_intensity_facev) > 0.001) {
        out_texc = FaceV(out_texc);
    }
    if (abs(intensity_facesmall) > 0.001) {
        out_texc = FaceSmall(out_texc);
    }
    if (abs(intensity_headsmall) > 0.001) {
        out_texc = HeadSmall(out_texc);
    }
    if (abs(intensity_facewidth) > 0.001 || abs(left_intensity_facewidth) > 0.001 || abs(right_intensity_facewidth) > 0.001) {
        out_texc = FaceWidth(out_texc);
    }
    if (abs(intensity_facelength) > 0.001) {
        out_texc = FaceLength(out_texc);
    }
    if (abs(intensity_jaw) > 0.001 || abs(left_intensity_jaw) > 0.001 || abs(right_intensity_jaw) > 0.001) {
        out_texc = Jaw(out_texc);
    }
    if (abs(intensity_cheekbone) > 0.001 || abs(left_intensity_cheekbone) > 0.001 || abs(right_intensity_cheekbone) > 0.001) {
        out_texc = Cheekbone(out_texc);
    }
    if (abs(intensity_temple) > 0.001 || abs(left_intensity_temple) > 0.001 || abs(right_intensity_temple) > 0.001) {
        out_texc = Temple(out_texc);
    }
    if (abs(intensity_hairline) > 0.001) {
        out_texc = Hairline(out_texc);
    }
    gl_FragColor = vec4(out_texc - texc, 0.0, 1.0);
}