varying vec2 texc;
uniform vec2 ver_nose;
uniform vec2 hor_nose;
uniform vec4 offset_wh;

uniform float intensity_nosesize;
uniform float scale_nosesize;
uniform sampler2D tex_nosesize;

uniform float intensity_nosewidth;
uniform float left_intensity_nosewidth;
uniform float right_intensity_nosewidth;
uniform float left_scale_nosewidth;
uniform float right_scale_nosewidth;
uniform sampler2D tex_nosewidth;

uniform float intensity_nosetip;
uniform float scale_nosetip;
uniform sampler2D tex_nosetip;

uniform float intensity_noselift;
uniform float scale_noselift;
uniform sampler2D tex_noselift;

uniform float intensity_nosebridge;
uniform float scale_nosebridge;
uniform sampler2D tex_nosebridge;

uniform float intensity_noseroot;
uniform float scale_noseroot;
uniform sampler2D tex_noseroot;

uniform float intensity_philtrum;
uniform float scale_philtrum;
uniform sampler2D tex_philtrum;

uniform sampler2D tex_uv_in;

vec2 NoseSize(vec2 texc_warp) {
    vec2 out_texc = texc_warp;
    vec4 maskColor = texture2D(tex_nosesize, texc + (out_texc - texc) / offset_wh.zw);
    vec2 newCoords = vec2(0.0);
    newCoords = (maskColor.rg - 127.0 / 255.0) / 25.0;

    vec2 off = abs(vec2(1.0) - texc_warp);
    vec2 off1 = abs(texc_warp);
    vec2 min_off = min(off, off1);
    vec2 modify_intensity = clamp(smoothstep(vec2(0.0), vec2(0.15, 0.1), min_off), vec2(0.55, 0.0), vec2(1.0, 1.0));

    vec2 newCoord_x = hor_nose * newCoords.x;
    vec2 newCoord_y = ver_nose * newCoords.y;

    if(abs(intensity_nosesize) > 0.001){
         out_texc += (newCoord_x + newCoord_y) * maskColor.a * intensity_nosesize * modify_intensity * scale_nosesize;
    }
    
    return out_texc;
}

vec2 MouthWidth(vec2 texc_warp) {
    vec2 out_texc = texc_warp;

    vec2 off = abs(vec2(1.0) - texc_warp);
    vec2 off1 = abs(texc_warp);
    vec2 min_off = min(off, off1);
    vec2 modify_intensity = clamp(smoothstep(vec2(0.0), vec2(0.15, 0.1), min_off), vec2(0.55, 0.0), vec2(1.0, 1.0));

    vec4 maskColor = texture2D(tex_nosewidth, texc + (out_texc - texc) / offset_wh.zw);
    vec2 newCoords = (maskColor.rg - 127.0 / 255.0) / 25.0;
    vec2 newCoord_x = hor_nose * newCoords.x;
    vec2 newCoord_y = ver_nose * newCoords.y;
    if(abs(left_intensity_nosewidth) > 0.001){       
        if (maskColor.b < 0.5) {
            out_texc += (newCoord_x + newCoord_y) * maskColor.a * left_intensity_nosewidth * modify_intensity * left_scale_nosewidth * smoothstep(0.5,0.48,maskColor.b);
        } 
    }

    maskColor = texture2D(tex_nosewidth, texc + (out_texc - texc) / offset_wh.zw);
    newCoords = (maskColor.rg - 127.0 / 255.0) / 25.0;
    newCoord_x = hor_nose * newCoords.x;
    newCoord_y = ver_nose * newCoords.y;
    if(abs(right_intensity_nosewidth) > 0.001){
        if (maskColor.b > 0.5) {
           out_texc += (newCoord_x + newCoord_y) * maskColor.a * right_intensity_nosewidth * modify_intensity * right_scale_nosewidth * smoothstep(0.5,0.52,maskColor.b);
        }
    }

    if(abs(intensity_nosewidth) > 0.001){
        if (maskColor.b < 0.5) {
            out_texc += (newCoord_x + newCoord_y) * maskColor.a * intensity_nosewidth * modify_intensity * left_scale_nosewidth;
        } else {
            out_texc += (newCoord_x + newCoord_y) * maskColor.a * intensity_nosewidth * modify_intensity * right_scale_nosewidth;
        }
    }
    
    return out_texc;
}

vec2 NoseTip(vec2 texc_warp) {
    vec2 out_texc = texc_warp;
    vec4 maskColor = texture2D(tex_nosetip, texc + (out_texc - texc) / offset_wh.zw);
    vec2 newCoords = vec2(0.0);
    newCoords = (maskColor.rg - 127.0 / 255.0) / 25.0;

    vec2 off = abs(vec2(1.0) - texc_warp);
    vec2 off1 = abs(texc_warp);
    vec2 min_off = min(off, off1);
    vec2 modify_intensity = clamp(smoothstep(vec2(0.0), vec2(0.15, 0.1), min_off), vec2(0.55, 0.0), vec2(1.0, 1.0));

    vec2 newCoord_x = hor_nose * newCoords.x;
    vec2 newCoord_y = ver_nose * newCoords.y;

    if(abs(intensity_nosetip) > 0.001){
         out_texc += (newCoord_x + newCoord_y) * maskColor.a * intensity_nosetip * modify_intensity * scale_nosetip;
    }
    
    return out_texc;
}

vec2 NoseLift(vec2 texc_warp) {
    vec2 out_texc = texc_warp;
    vec4 maskColor = texture2D(tex_noselift, texc + (out_texc - texc) / offset_wh.zw);
    vec2 newCoords = vec2(0.0);
    newCoords = (maskColor.rg - 127.0 / 255.0) / 25.0;

    vec2 off = abs(vec2(1.0) - texc_warp);
    vec2 off1 = abs(texc_warp);
    vec2 min_off = min(off, off1);
    vec2 modify_intensity = clamp(smoothstep(vec2(0.0), vec2(0.15, 0.1), min_off), vec2(0.55, 0.0), vec2(1.0, 1.0));

    vec2 newCoord_x = hor_nose * newCoords.x;
    vec2 newCoord_y = ver_nose * newCoords.y;

    if(abs(intensity_noselift) > 0.001){
         out_texc += (newCoord_x + newCoord_y) * maskColor.a * intensity_noselift * modify_intensity * scale_noselift;
    }
    
    return out_texc;
}

vec2 NoseBridge(vec2 texc_warp) {
    vec2 out_texc = texc_warp;
    vec4 maskColor = texture2D(tex_nosebridge, texc + (out_texc - texc) / offset_wh.zw);
    vec2 newCoords = vec2(0.0);
    newCoords = (maskColor.rg - 127.0 / 255.0) / 25.0;

    vec2 off = abs(vec2(1.0) - texc_warp);
    vec2 off1 = abs(texc_warp);
    vec2 min_off = min(off, off1);
    vec2 modify_intensity = clamp(smoothstep(vec2(0.0), vec2(0.15, 0.1), min_off), vec2(0.55, 0.0), vec2(1.0, 1.0));

    vec2 newCoord_x = hor_nose * newCoords.x;
    vec2 newCoord_y = ver_nose * newCoords.y;

    if(abs(intensity_nosebridge) > 0.001){
         out_texc += (newCoord_x + newCoord_y) * maskColor.a * intensity_nosebridge * modify_intensity * scale_nosebridge;
    }
    
    return out_texc;
}

vec2 NoseRoot(vec2 texc_warp) {
    vec2 out_texc = texc_warp;
    vec4 maskColor = texture2D(tex_noseroot, texc + (out_texc - texc) / offset_wh.zw);
    vec2 newCoords = vec2(0.0);
    newCoords = (maskColor.rg - 127.0 / 255.0) / 25.0;

    vec2 off = abs(vec2(1.0) - texc_warp);
    vec2 off1 = abs(texc_warp);
    vec2 min_off = min(off, off1);
    vec2 modify_intensity = clamp(smoothstep(vec2(0.0), vec2(0.15, 0.1), min_off), vec2(0.55, 0.0), vec2(1.0, 1.0));

    vec2 newCoord_x = hor_nose * newCoords.x;
    vec2 newCoord_y = ver_nose * newCoords.y;

    if(abs(intensity_noseroot) > 0.001){
         out_texc += (newCoord_x + newCoord_y) * maskColor.a * intensity_noseroot * modify_intensity * scale_noseroot;
    }
    
    return out_texc;
}

vec2 Philtrum(vec2 texc_warp) {
    vec2 out_texc = texc_warp;
    vec4 maskColor = texture2D(tex_philtrum, texc + (out_texc - texc) / offset_wh.zw);
    maskColor = vec4(127.0 / 255.0,0.32,maskColor.a,maskColor.g);
    vec2 newCoords = vec2(0.0);
    newCoords = (maskColor.rg - 127.0 / 255.0) / 25.0;

    vec2 off = abs(vec2(1.0) - texc_warp);
    vec2 off1 = abs(texc_warp);
    vec2 min_off = min(off, off1);
    vec2 modify_intensity = clamp(smoothstep(vec2(0.0), vec2(0.15, 0.1), min_off), vec2(0.55, 0.0), vec2(1.0, 1.0));

    vec2 newCoord_x = hor_nose * newCoords.x;
    vec2 newCoord_y = ver_nose * newCoords.y;

    if(abs(intensity_philtrum) > 0.001){
         out_texc += (newCoord_x + newCoord_y) * maskColor.a * intensity_philtrum * modify_intensity * scale_philtrum;
    }
    
    return out_texc;
}

void main(){
    vec2 out_texc = texc + texture2D(tex_uv_in, texc).rg;
    if (abs(intensity_philtrum) > 0.001) {
        out_texc = Philtrum(out_texc);
    }
    if (abs(intensity_noselift) > 0.001) {
        out_texc = NoseLift(out_texc);
    }
    if (abs(intensity_nosesize) > 0.001) {
        out_texc = NoseSize(out_texc);
    }
    if (abs(intensity_nosewidth) > 0.001 || abs(left_intensity_nosewidth) > 0.001 || abs(right_intensity_nosewidth) > 0.001) {
        out_texc = MouthWidth(out_texc);
    }
    if (abs(intensity_nosetip) > 0.001) {
        out_texc = NoseTip(out_texc);
    }
    if (abs(intensity_nosebridge) > 0.001) {
        out_texc = NoseBridge(out_texc);
    }
    if (abs(intensity_noseroot) > 0.001) {
        out_texc = NoseRoot(out_texc);
    }
    gl_FragColor = vec4(out_texc - texc, 0.0, 1.0);
}