(function () {
	reshape.Init();
	reshape3d.Init();

	var retobj = {
		RenderBeforeReshape:function(){
			if(reshape3d.DoneReshape() && reshape.DoneReshape()){
				EffectSDK.updateLandmarks();
			}		
		},
		RenderReshape:function(){
			reshape3d.Render();
			reshape.Render();
		},
		SetParam:function(name,value){
			console.logd("SetParam name:",name," value:",value);
			if(name == "Reset"){
				reshape3d.SetParam(name, value);
				reshape.SetParam(name, value);
				return 0;
			}
			if(name.includes("intensity_reshape3d")){
				return reshape3d.SetParam(name, value);
			}else{
				return reshape.SetParam(name, value);
			} 
		},
		GetParam:function(name){
			if(name.includes("intensity_reshape3d")){
				return reshape3d.GetParam(name);
			}else{
				return reshape.GetParam(name);
			}
		},
		SetConfig:function(param){
			return reshape.SetConfig(param);
		},
		BindItem:function(item){
			if (item.makeup_info != undefined) {
				if(item.makeup_info["item_type"] == "combination"){
					reshape.ResetParam(false);
				}
				for (var key in item.makeup_info) {
					var value = item.makeup_info[key];
					this.SetParam(key, value);
				}
			}
		},
		SetItemsQueue:function(item){
			reshape.SetItemsQueue(item);
		},
		Destroy:function(){
			reshape.Release();
			reshape3d.Release();
		},
		name:"reshape",		
	};

	return retobj; 
})()
