varying vec2 offset;
//varying vec2 texc;
//uniform mat4 modelM;
uniform vec3 whd;
uniform vec2 max_min_z;
uniform vec3 x_dir;
uniform vec3 y_dir;
uniform vec3 z_dir;
uniform vec3 center_3d;
uniform float intensity_reshape3d_rotation;
uniform float intensity_reshape3d_leftright;
uniform float intensity_reshape3d_updown;

// void main(){
//     vec4 pos = modelM * vec4(Pointv, 1.0);
//     pos.xyz /= pos.w;
//     pos.y = pos.y * whd.x / whd.y;
//     gl_Position = vec4(pos.xy * 2.0 - 1.0,pos.z, 1.0);
//     vec2 p = vec2(Pointv.x,Pointv.y * whd.x / whd.y);
//     offset = p.xy - pos.xy;
//     float z_rate = 1.0 - (Pointv.z - max_min_z.y) * (max_min_z.x - max_min_z.y);
//     //offset *= min(0.3, z_rate);
//     offset *= z_rate;
// }

mat4 identity() {
    return mat4(
        vec4(1.0, 0.0, 0.0, 0.0),
        vec4(0.0, 1.0, 0.0, 0.0),
        vec4(0.0, 0.0, 1.0, 0.0),
        vec4(0.0, 0.0, 0.0, 1.0)
    );
}

mat4 translate(vec3 v) {
    mat4 result = identity();
    result[3] = vec4(v, 1.0);
    return result;
}

mat4 rotateX(float angle) {
    float s = sin(angle);
    float c = cos(angle);
    
    return mat4(
        vec4(1.0, 0.0, 0.0, 0.0),
        vec4(0.0, c, s, 0.0),
        vec4(0.0, -s, c, 0.0),
        vec4(0.0, 0.0, 0.0, 1.0)
    );
}

mat4 rotateY(float angle) {
    float s = sin(angle);
    float c = cos(angle);
    
    return mat4(
        vec4(c, 0.0, -s, 0.0),
        vec4(0.0, 1.0, 0.0, 0.0),
        vec4(s, 0.0, c, 0.0),
        vec4(0.0, 0.0, 0.0, 1.0)
    );
}

mat4 rotateZ(float angle) {
    float s = sin(angle);
    float c = cos(angle);
    
    return mat4(
        vec4(c, s, 0.0, 0.0),
        vec4(-s, c, 0.0, 0.0),
        vec4(0.0, 0.0, 1.0, 0.0),
        vec4(0.0, 0.0, 0.0, 1.0)
    );
}

mat4 rotate(float angle, vec3 axis) {
    float s = sin(angle);
    float c = cos(angle);
    float oc = 1.0 - c;
    
    axis = normalize(axis);
    
    return mat4(
        vec4(oc * axis.x * axis.x + c,           oc * axis.x * axis.y - axis.z * s,  oc * axis.z * axis.x + axis.y * s,  0.0),
        vec4(oc * axis.x * axis.y + axis.z * s,  oc * axis.y * axis.y + c,           oc * axis.y * axis.z - axis.x * s,  0.0),
        vec4(oc * axis.z * axis.x - axis.y * s,  oc * axis.y * axis.z + axis.x * s,  oc * axis.z * axis.z + c,          0.0),
        vec4(0.0,                                0.0,                                0.0,                                1.0)
    );
}

void main() {
    float z_rate = 1.0 - (Pointv.z - max_min_z.y) / (max_min_z.x - max_min_z.y);
    //z_rate = smoothstep(0.0,1.0,z_rate * z_rate);
    z_rate *= z_rate;
    float pi = 3.1415926;

    mat4 model_Dir = translate(center_3d) * rotate(6.0 * pi / 180.0 * intensity_reshape3d_rotation * z_rate, z_dir) * translate(-1.0 * center_3d);
    vec4 y_r_dir = model_Dir * vec4(y_dir, 1.0);

    model_Dir = translate(center_3d) * rotate(15.0f * pi / 180.0 * intensity_reshape3d_leftright * z_rate, y_r_dir.xyz) * rotate(6.0f * pi / 180.0 * intensity_reshape3d_rotation * z_rate, z_dir) * translate(-1.0 * center_3d);
	vec4 x_r_dir = model_Dir * vec4(x_dir, 1.0);

	mat4 modelM = translate(center_3d) * rotate(15.0f * pi / 180.0 * intensity_reshape3d_updown * z_rate, x_r_dir.xyz) * rotate(15.0f * pi / 180.0 * intensity_reshape3d_leftright * z_rate, y_r_dir.xyz) * rotate(6.0f * pi / 180.0 * intensity_reshape3d_rotation * z_rate, z_dir) * translate(-1.0 * center_3d);
	
    vec4 pos = modelM * vec4(Pointv, 1.0);
    pos.xyz /= pos.w;
    pos.y = pos.y * whd.x / whd.y;
    gl_Position = vec4(pos.xy * 2.0 - 1.0,pos.z, 1.0);
    vec2 p = vec2(Pointv.x,Pointv.y * whd.x / whd.y);
    offset = p.xy - pos.xy;
    //texc = pos.xy;
}